EBB_Bar = AceLibrary("AceOO-2.0").Class()

function EBB_Bar:ToString()
	return "EBB_Bar"
end

function EBB_Bar.prototype:Init2()
	self.data = {}
	self.frames = {}
	self.layout = {}
end

function EBB_Bar.prototype:GetContainer()
	return self.frames.container
end

function EBB_Bar.prototype:SetParent(parent)
	if self.frames.container then
		self.frames.container:SetParent(parent)
		if self.frames.bar then
			self.frames.container:SetFrameLevel(self.frames.bar:GetFrameLevel() + 1) -- fix frame order
		end
	end
end

function EBB_Bar.prototype:UpdateLayout(layout)
	if layout then
		self.layout = layout
	else
		layout = self.layout
	end
	
-- container
	if not self.frames.container then
		self.frames.container = CreateFrame("button", nil, UIParent)
		self.frames.container:SetFrameStrata("BACKGROUND")
	end
	self.frames.container:SetHeight(layout.height)
	self.frames.container:SetWidth(layout.width)
	local leftoffset = 0
	local rightoffset = 0

-- icon
	if layout.icon then
		if not self.frames.icon then
			self.frames.icon = self.frames.container:CreateTexture(nil, "ARTWORK")
		end
		self.frames.icon:ClearAllPoints()
		self.frames.icon:SetHeight(layout.height)
		self.frames.icon:SetWidth(layout.height)
		if layout.icon == "LEFT" then
			leftoffset = layout.height
			self.frames.icon:SetPoint("LEFT", self.frames.container)
			
		end
		if layout.icon == "RIGHT" then
			rightoffset = -layout.height
			self.frames.icon:SetPoint("RIGHT", self.frames.container)
			
		end
		self.frames.icon:Show()
	else
		if self.frames.icon then self.frames.icon:Hide() end
	end

-- iconcount
	if layout.icon and layout.iconcount then
		if not self.frames.iconcount then
			self.frames.iconcount = self.frames.container:CreateFontString(nil, "OVERLAY")
		end
		self.frames.iconcount:ClearAllPoints()
		self.frames.iconcount:SetPoint(layout.iconcountanchor, self.frames.icon, layout.iconcountanchor, (string.find(layout.iconcountanchor, "LEFT") and 3) or (string.find(layout.iconcountanchor, "RIGHT") and -3) or 0, (string.find(layout.iconcountanchor, "TOP") and -3) or (string.find(layout.iconcountanchor, "BOTTOM") and 3) or 0)
		self.frames.iconcount:SetFont(layout.iconcountfont, layout.iconcountfontsize)
		self.frames.iconcount:Show()
	else
		if self.frames.iconcount then self.frames.iconcount:Hide() end
	end

-- iconborder
	if layout.icon then
		if not self.frames.iconborder then
			self.frames.iconborder = self.frames.container:CreateTexture(nil, "OVERLAY")
		end
		self.frames.iconborder:ClearAllPoints()
		self.frames.iconborder:SetPoint("TOPLEFT", self.frames.icon)
		self.frames.iconborder:SetPoint("BOTTOMRIGHT", self.frames.icon)
		self.frames.iconborder:Show()
	else
		if self.frames.iconborder then self.frames.iconborder:Hide() end
	end

-- bar
	if layout.bar then
		if not self.frames.bgbar then
			self.frames.bgbar = CreateFrame("StatusBar", nil, self.frames.container)
		end
		self.frames.bgbar:ClearAllPoints()
		self.frames.bgbar:SetPoint("TOPLEFT", self.frames.container, "TOPLEFT", leftoffset, 0)
		self.frames.bgbar:SetPoint("BOTTOMRIGHT", self.frames.container, "BOTTOMRIGHT", rightoffset, 0)
		self.frames.bgbar:SetFrameStrata("BACKGROUND")
		self.frames.bgbar:SetFrameLevel(self.frames.container:GetFrameLevel() + 1)
		self.frames.bgbar:SetStatusBarTexture(layout.bar)
		self.frames.bgbar:SetMinMaxValues(0, 1)
		self.frames.bgbar:SetValue(1)
		self.frames.bgbar:Show()

		if not self.frames.bar then
			self.frames.bar = CreateFrame("StatusBar", nil, self.frames.container)
		end
		self.frames.bar:ClearAllPoints()
		self.frames.bar:SetPoint("TOPLEFT", self.frames.container, "TOPLEFT", leftoffset, 0)
		self.frames.bar:SetPoint("BOTTOMRIGHT", self.frames.container, "BOTTOMRIGHT", rightoffset, 0)
		self.frames.bar:SetFrameStrata("BACKGROUND")
		self.frames.bar:SetFrameLevel(self.frames.bgbar:GetFrameLevel() + 1)
		self.frames.bar:SetStatusBarTexture(layout.bar)
		self.frames.bar:Show()

		self.frames.container:SetFrameLevel(self.frames.bar:GetFrameLevel() + 1) -- fix frame order
	else
		if self.frames.bgbar then self.frames.bgbar:Hide() end
		if self.frames.bar then self.frames.bar:Hide() end
	end

-- textTL
	if layout.textTL then
		if not self.frames.textTL then
			self.frames.textTL = self.frames.container:CreateFontString(nil, "OVERLAY")
		end
		self.frames.textTL:ClearAllPoints()
		self.frames.textTL:SetPoint("TOPLEFT", self.frames.container, "TOPLEFT", leftoffset + 2, -2)
		self.frames.textTL:SetFontObject(GameFontNormal)
		self.frames.textTL:SetFont(layout.textTLfont, layout.textTLfontsize)
		self.frames.textTL:SetTextColor(layout.textTLcolor[1], layout.textTLcolor[2], layout.textTLcolor[3], 1)
		self.frames.textTL:SetJustifyH((layout.textTR and "LEFT") or layout.textTLalign)
		if not layout.textBL then
			self.frames.textTL:SetPoint("BOTTOMLEFT", self.frames.container, "BOTTOMLEFT", leftoffset + 2, 2)
			self.frames.textTL:SetJustifyV("CENTER")
		else
			self.frames.textTL:SetJustifyV("TOP")
		end
		self.frames.textTL:Show()
	else
		if self.frames.textTL then self.frames.textTL:Hide() end
	end

-- textTR
	if layout.textTR then
		if not self.frames.textTR then
			self.frames.textTR = self.frames.container:CreateFontString(nil, "OVERLAY")
		end
		self.frames.textTR:ClearAllPoints()
		self.frames.textTR:SetPoint("TOPRIGHT", self.frames.container, "TOPRIGHT", rightoffset - 2, -2)
		self.frames.textTR:SetFontObject(GameFontNormal)
		self.frames.textTR:SetFont(layout.textTRfont, layout.textTRfontsize)
		self.frames.textTR:SetTextColor(layout.textTRcolor[1], layout.textTRcolor[2], layout.textTRcolor[3], 1)
		self.frames.textTR:SetJustifyH("RIGHT")
		if not layout.textBL then
			self.frames.textTR:SetPoint("BOTTOMRIGHT", self.frames.container, "BOTTOMRIGHT", rightoffset - 2, 2)
			self.frames.textTR:SetJustifyV("CENTER")
		else
			self.frames.textTR:SetJustifyV("TOP")
		end
		self.frames.textTR:Show()
	else
		if self.frames.textTR then self.frames.textTR:Hide() end
	end

-- textBL
	if layout.textTL and layout.textBL then
		if not self.frames.textBL then
			self.frames.textBL = self.frames.container:CreateFontString(nil, "OVERLAY")
		end
		self.frames.textBL:ClearAllPoints()
		self.frames.textBL:SetPoint("BOTTOMLEFT", self.frames.container, "BOTTOMLEFT", leftoffset + 2, 2)
		self.frames.textBL:SetFontObject(GameFontNormal)
		self.frames.textBL:SetFont(layout.textBLfont, layout.textBLfontsize)
		self.frames.textBL:SetTextColor(layout.textBLcolor[1], layout.textBLcolor[2], layout.textBLcolor[3], 1)
		self.frames.textBL:SetJustifyH((layout.textBR and "LEFT") or layout.textBLalign)
		self.frames.textBL:Show()
	else
		if self.frames.textBL then self.frames.textBL:Hide() end
	end

-- textTR
	if layout.textTL and layout.textBR then
		if not self.frames.textBR then
			self.frames.textBR = self.frames.container:CreateFontString(nil, "OVERLAY")
		end
		self.frames.textBR:ClearAllPoints()
		self.frames.textBR:SetPoint("BOTTOMRIGHT", self.frames.container, "BOTTOMRIGHT", rightoffset - 2, 2)
		self.frames.textBR:SetFontObject(GameFontNormal)
		self.frames.textBR:SetFont(layout.textBRfont, layout.textBRfontsize)
		self.frames.textBR:SetTextColor(layout.textBRcolor[1], layout.textBRcolor[2], layout.textBRcolor[3], 1)
		self.frames.textBR:SetJustifyH("RIGHT")
		self.frames.textBR:Show()
	else
		if self.frames.textBR then self.frames.textBR:Hide() end
	end
end

function EBB_Bar.prototype:UpdateData(data)
	if data then
		self.data = data
	else
		data = self.data
	end

	if self.layout.icon then
		self.frames.icon:SetTexture(data.icon)
		if data.type == "DEBUFF" then
			self.frames.iconborder:SetTexture("Interface\\Buttons\\UI-Debuff-Overlays")
			self.frames.iconborder:SetTexCoord(0.296875, 0.5703125, 0, 0.515625)
			local debuffcolor
			if ( data.debufftype ) then
				debuffcolor = DebuffTypeColor[data.debufftype]
			else
				debuffcolor = DebuffTypeColor["none"]
			end
			self.frames.iconborder:SetVertexColor(debuffcolor.r, debuffcolor.g, debuffcolor.b)
			self.frames.iconborder:Show()
		elseif data.type == "TENCH" then
			self.frames.iconborder:SetTexture("Interface\\Buttons\\UI-TempEnchant-Border")
			self.frames.iconborder:SetTexCoord(0, 1, 0, 1)
			self.frames.iconborder:Show()
		else
			self.frames.iconborder:Hide()
		end
	end
	if self.layout.iconcount then
		if data.count > 1 then
			self.frames.iconcount:SetText(data.count)
			self.frames.iconcount:Show()
		else
			self.frames.iconcount:Hide()
		end
	end
	if self.layout.bar then
		if data.untilCancelled then
			self.frames.bar:SetMinMaxValues(0, 1)
			self.frames.bar:SetValue(0)
		else
			self.frames.bar:SetMinMaxValues(0, data.timemax)
			self.frames.bar:SetValue(data.timeleft)
		end
		local color = self.layout[(data.type).."color"]
		if data.type == "DEBUFF" and self.layout.debufftypecolor then
			local debuffcolor
			if ( data.debufftype ) then
				debuffcolor = DebuffTypeColor[data.debufftype]
			else
				debuffcolor = DebuffTypeColor["none"]
			end
			color = {debuffcolor.r, debuffcolor.g, debuffcolor.b}
		end
		self.frames.bar:SetStatusBarColor(color[1], color[2], color[3], 0.8)
		color = self.layout[(data.type).."bgcolor"]
		self.frames.bgbar:SetStatusBarColor(color[1], color[2], color[3], 0.3)
	end
	if self.layout.textTL then
		self.frames.textTL:SetText(self:GetDataString(self.layout.textTL))
	end
	if self.layout.textTR then
		self.frames.textTR:SetText(self:GetDataString(self.layout.textTR))
	end
	if self.layout.textTL and self.layout.textBL then
		self.frames.textBL:SetText(self:GetDataString(self.layout.textBL))
	end
	if self.layout.textTL and self.layout.textBR then
		self.frames.textBR:SetText(self:GetDataString(self.layout.textBR))
	end
end

local romandigits = {	{["r"] = "M",  ["a"] = 1000},
						{["r"] = "CM", ["a"] =  900},
						{["r"] = "D",  ["a"] =  500},
						{["r"] = "CD", ["a"] =  400},
						{["r"] = "C",  ["a"] =  100},
						{["r"] = "XC", ["a"] =   90},
						{["r"] = "L",  ["a"] =   50},
						{["r"] = "XL", ["a"] =   40},
						{["r"] = "X",  ["a"] =   10},
						{["r"] = "IX", ["a"] =    9},
						{["r"] = "V",  ["a"] =    5},
						{["r"] = "IV", ["a"] =    4},
						{["r"] = "I",  ["a"] =    1}
					}

local function arabic_to_roman(arabic)
	local roman = ""
	for i = 1, #romandigits do
		while arabic >= romandigits[i].a do
			arabic = arabic - romandigits[i].a
			roman = roman..romandigits[i].r
		end
	end
	return roman
end

function EBB_Bar.prototype:GetDataString(datatype)
	if datatype == "NAME" then return self.data.name end
	if datatype == "NAMERANK" then return self.data.name.." "..arabic_to_roman(self.data.rank) end
	if datatype == "NAMECOUNT" then return self.data.name..((self.data.count > 1) and " x"..self.data.count or "") end
	if datatype == "NAMERANKCOUNT" then return self.data.name.." "..arabic_to_roman(self.data.rank)..((self.data.count > 1) and " x"..self.data.count or "") end
	if datatype == "RANK" then return arabic_to_roman(self.data.rank) end
	if datatype == "COUNT" then return ((self.data.count > 1) and "x"..self.data.count or "") end
	if datatype == "TIMELEFT" then return self:GetTimeString(self.data.timeleft, self.layout.timeformat) end
	if datatype == "DEBUFFTYPE" then return self.data.debufftype end
	return "???"
end

function EBB_Bar.prototype:GetTimeString(time, format)
	local abacus = AceLibrary("Abacus-2.0")
	if format == "DEFAULT" then return SecondsToTimeAbbrev(time) end
	if format == "EXTENDED" then return abacus:FormatDurationExtended(time) end
	if format == "FULL" then return abacus:FormatDurationFull(time) end
	if format == "SHORT" then return abacus:FormatDurationShort(time) end
	if format == "CONDENSED" then return abacus:FormatDurationCondensed(time) end
	return "???"
end

function EBB_Bar.prototype:UpdateTimeleft(timeleft)
	self.data.timeleft = timeleft
	if self.layout.bar and not data.untilCancelled then
		self.frames.bar:SetValue(data.timeleft)
	end
	if self.layout.textTL == "TIMELEFT" then
		self.frames.textTL:SetText(self:GetDataString("TIMELEFT"))
	end
	if self.layout.textTR == "TIMELEFT" then
		self.frames.textTR:SetText(self:GetDataString("TIMELEFT"))
	end
	if self.layout.textTL and self.layout.textBL == "TIMELEFT" then
		self.frames.textBL:SetText(self:GetDataString("TIMELEFT"))
	end
	if self.layout.textTL and self.layout.textBR == "TIMELEFT" then
		self.frames.textBR:SetText(self:GetDataString("TIMELEFT"))
	end
end
